'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _from = require('babel-runtime/core-js/array/from');

var _from2 = _interopRequireDefault(_from);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _zombie = require('zombie');

var _zombie2 = _interopRequireDefault(_zombie);

var _uuid = require('uuid');

var _uuid2 = _interopRequireDefault(_uuid);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var browser = new _zombie2.default();
browser.visit('about:blank');

function throwError(status, message) {
  var err = new Error(message);
  err.webdriverError = { status: status, value: { message: message } };
  throw err;
}

var timeouts = {};

var elements = new _map2.default();

function getElementById(id) {
  return elements.get(id);
}
function storeElement(element) {
  if (!element) {
    throwError(7, 'No element found');
  }
  var elementID = (0, _uuid2.default)();
  elements.set(elementID, element);
  return { ELEMENT: elementID };
}
var driver = {
  getActiveWindowHandle: function getActiveWindowHandle() {
    return '' + browser.tabs.index;
  },
  setTimeouts: function setTimeouts(_ref) {
    var _ref$body = _ref.body,
        type = _ref$body.type,
        ms = _ref$body.ms;

    timeouts[type] = ms;
  },
  setAsyncScriptTimeOut: function setAsyncScriptTimeOut(_ref2) {
    var ms = _ref2.body.ms;

    timeouts.async = ms;
  },
  setUrl: function setUrl(_ref3) {
    var url = _ref3.body.url;
    return _regenerator2.default.async(function setUrl$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _regenerator2.default.awrap(browser.visit(url));

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, null, this);
  },
  getUrl: function getUrl() {
    return browser.url;
  },
  getElement: function getElement(_ref4) {
    var _ref4$body = _ref4.body,
        using = _ref4$body.using,
        value = _ref4$body.value;

    var element = this.getElements({ body: { using: using, value: value } })[0];
    if (!element) {
      throwError(7, 'No element found');
    }
    return element;
  },
  getElements: function getElements(_ref5) {
    var _ref5$body = _ref5.body,
        using = _ref5$body.using,
        value = _ref5$body.value;

    var document = browser.document;
    switch (using) {
      case 'class name':
        return (0, _from2.default)(document.getElementsByClassName(value)).map(storeElement);
      case 'css selector':
        return (0, _from2.default)(document.querySelectorAll(value)).map(storeElement);
      case 'id':
        return [storeElement(document.getElementById(value))];
      case 'link text':
        return (0, _from2.default)(document.getElementsByTagName('a')).filter(function (link) {
          return link.textContent === value;
        }).map(storeElement);
      case 'partial link text':
        return (0, _from2.default)(document.getElementsByTagName('a')).filter(function (link) {
          return link.textContent.includes(value);
        }).map(storeElement);
      case 'name':
        return (0, _from2.default)(document.querySelectorAll('[name="' + value + '"]')).map(storeElement);
      case 'tag':
        return (0, _from2.default)(document.getElementsByTagName(value)).map(storeElement);
      default:
        throw new Error('Invalid using: ' + using);
    }
  },
  compareElements: function compareElements(_ref6) {
    var _ref6$params = _ref6.params,
        elementA = _ref6$params.elementA,
        elementB = _ref6$params.elementB;

    return getElementById(elementA) === getElementById(elementB);
  },
  getActiveElement: function getActiveElement() {
    return storeElement(browser.activeElement);
  },
  getSource: function getSource() {
    // TODO: use proper serialize method
    return '<!DOCTYPE html>\n' + browser.document.documentElement.outerHTML;
  },
  getTitle: function getTitle() {
    return browser.document.title;
  },
  sendKeys: function sendKeys(_ref7) {
    var value = _ref7.body.value;

    var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, key, options, KeyboardEvent;

    return _regenerator2.default.async(function sendKeys$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context2.prev = 3;
            _iterator = (0, _getIterator3.default)(value);

          case 5:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context2.next = 17;
              break;
            }

            key = _step.value;

            // key is a single character
            options = {
              key: key.toLowerCase(),
              char: key,
              charCode: key.charCodeAt(0),
              shiftKey: key !== key.toLowerCase(),
              keyCode: key.toUpperCase().charCodeAt(0)
            };
            KeyboardEvent = browser.window.KeyboardEvent;

            browser.activeElement.dispatchEvent(new KeyboardEvent('keydown', options));
            browser.activeElement.dispatchEvent(new KeyboardEvent('keypress', options));
            browser.activeElement.dispatchEvent(new KeyboardEvent('keyup', options));
            _context2.next = 14;
            return _regenerator2.default.awrap(browser.wait());

          case 14:
            _iteratorNormalCompletion = true;
            _context2.next = 5;
            break;

          case 17:
            _context2.next = 23;
            break;

          case 19:
            _context2.prev = 19;
            _context2.t0 = _context2['catch'](3);
            _didIteratorError = true;
            _iteratorError = _context2.t0;

          case 23:
            _context2.prev = 23;
            _context2.prev = 24;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 26:
            _context2.prev = 26;

            if (!_didIteratorError) {
              _context2.next = 29;
              break;
            }

            throw _iteratorError;

          case 29:
            return _context2.finish(26);

          case 30:
            return _context2.finish(23);

          case 31:
          case 'end':
            return _context2.stop();
        }
      }
    }, null, this, [[3, 19, 23, 31], [24,, 26, 30]]);
  },
  goBack: function goBack() {
    return _regenerator2.default.async(function goBack$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return _regenerator2.default.awrap(browser.back());

          case 2:
          case 'end':
            return _context3.stop();
        }
      }
    }, null, this);
  },
  goForward: function goForward() {
    return _regenerator2.default.async(function goForward$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return _regenerator2.default.awrap(browser.history.forward());

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, null, this);
  },
  refresh: function refresh() {
    return _regenerator2.default.async(function refresh$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return _regenerator2.default.awrap(browser.reload());

          case 2:
          case 'end':
            return _context5.stop();
        }
      }
    }, null, this);
  },
  execute: function execute(_ref8) {
    var _ref8$body = _ref8.body,
        script = _ref8$body.script,
        args = _ref8$body.args;

    return browser.window.Function('', script).apply(undefined, (0, _toConsumableArray3.default)(args));
  },
  setCookie: function setCookie(_ref9) {
    var cookie = _ref9.body.cookie;

    browser.cookies.set(cookie);
  },
  getCookies: function getCookies() {
    return browser.cookies.map(function (cookie) {
      var result = {};
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = (0, _getIterator3.default)((0, _keys2.default)(cookie)), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var key = _step2.value;

          if (key === 'key') {
            result.name = cookie.key;
          } else {
            result[key] = cookie[key];
          }
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return result;
    });
  },
  deleteCookie: function deleteCookie(_ref10) {
    var key = _ref10.params.key;

    var cookie = browser.cookies.find(function (cookie) {
      return cookie.key === key;
    });
    if (cookie) {
      browser.cookies.delete(cookie);
    }
  },
  deleteAllCookies: function deleteAllCookies() {
    browser.cookies.deleteAll();
  },
  closeActiveWindow: function closeActiveWindow() {
    browser.tabs.close(browser.tabs.index);
  }
};

var elementMethods = {
  click: function click(element) {
    return _regenerator2.default.async(function click$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return _regenerator2.default.awrap(browser.click(element));

          case 2:
          case 'end':
            return _context6.stop();
        }
      }
    }, null, this);
  },
  getAttribute: function getAttribute(element, _ref11) {
    var attributeName = _ref11.params.attributeName;

    if (attributeName === 'value') {
      return element.value;
    }
    return element.getAttribute(attributeName);
  },
  getCssProperty: function getCssProperty(element, _ref12) {
    var propertyName = _ref12.params.propertyName;

    // TODO: convert css property name into JavaScript property name
    return browser.window.getComputedStyle(element)[propertyName];
  },
  getEnabled: function getEnabled(element) {
    return !element.hasAttribute('disabled');
  },
  getSelected: function getSelected(element) {
    return element.hasAttribute('checked');
  },
  getTagName: function getTagName(element) {
    return element.tagName.toLowerCase();
  },
  getText: function getText(element) {
    return element.textContent;
  },
  submit: function submit(element) {
    return _regenerator2.default.async(function submit$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return _regenerator2.default.awrap(browser.fire(element, 'submit'));

          case 2:
          case 'end':
            return _context7.stop();
        }
      }
    }, null, this);
  },
  getElement: function getElement(parentElement, _ref13) {
    var _ref13$body = _ref13.body,
        using = _ref13$body.using,
        value = _ref13$body.value;

    var element = this.getElements(parentElement, { body: { using: using, value: value } })[0];
    if (!element) {
      throwError(7, 'No element found');
    }
    return element;
  },
  getElements: function getElements(element, _ref14) {
    var _ref14$body = _ref14.body,
        using = _ref14$body.using,
        value = _ref14$body.value;

    switch (using) {
      case 'class name':
        return (0, _from2.default)(element.getElementsByClassName(value)).map(storeElement);
      case 'css selector':
        return (0, _from2.default)(element.querySelectorAll(value)).map(storeElement);
      case 'id':
        return [storeElement(element.getElementById(value))];
      case 'link text':
        return (0, _from2.default)(element.getElementsByTagName('a')).filter(function (link) {
          return link.textContent === value;
        }).map(storeElement);
      case 'partial link text':
        return (0, _from2.default)(element.getElementsByTagName('a')).filter(function (link) {
          return link.textContent.includes(value);
        }).map(storeElement);
      case 'name':
        return (0, _from2.default)(element.querySelectorAll('[name="' + value + '"]')).map(storeElement);
      case 'tag':
        return (0, _from2.default)(element.getElementsByTagName(value)).map(storeElement);
      default:
        throw new Error('Invalid using: ' + using);
    }
  },
  clear: function clear(element) {
    return _regenerator2.default.async(function clear$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            browser.fill(element, '');

          case 1:
          case 'end':
            return _context8.stop();
        }
      }
    }, null, this);
  },
  appendValue: function appendValue(element, _ref15) {
    var value = _ref15.body.value;

    browser.fill(element, element.value + value.join(''));
  },
  getDisplayed: function getDisplayed(element) {
    return browser.window.getComputedStyle(element).display !== 'none';
  }
};

var storage = {
  setItem: function setItem(id, _ref16) {
    var _ref16$body = _ref16.body,
        key = _ref16$body.key,
        value = _ref16$body.value;

    browser.window[id].setItem(key, value);
  },
  getItem: function getItem(id, _ref17) {
    var key = _ref17.params.key;

    return browser.window[id].getItem(key);
  },
  getKeys: function getKeys(id) {
    var keys = [];
    for (var i = 0; i < browser.window[id].length; i++) {
      keys.push(browser.window[id].key(i));
    }
    return keys;
  },
  getSize: function getSize(id) {
    return browser.window[id].length;
  },
  removeItem: function removeItem(id, _ref18) {
    var key = _ref18.params.key;

    browser.window[id].removeItem(key);
  },
  clear: function clear(id) {
    browser.window[id].clear();
  }
};

function handleMessage(_ref19) {
  var level = _ref19.level,
      method = _ref19.method,
      params = _ref19.params,
      body = _ref19.body;

  switch (level) {
    case 'driver':
      if (typeof driver[method] !== 'function') {
        throwError(9, 'Unknown command driver.' + method);
      }
      return driver[method]({ params: params, body: body });
    case 'element':
      if (typeof elementMethods[method] !== 'function') {
        throwError(9, 'Unknown command element.' + method);
      }
      return elementMethods[method](getElementById(params.elementId), { params: params, body: body });
    case 'storage':
      if (typeof storage[method] !== 'function') {
        throwError(9, 'Unknown command storage.' + method);
      }
      return storage[method](params.level === 'local_storage' ? 'localStorage' : params.level === 'session_storage' ? 'sessionStorage' : function () {
        throw new Error('Unknown storage level ' + params.level);
      }(), { params: params, body: body });
    case 'session_storage':
      if (typeof storage[method] !== 'function') {
        throwError(9, 'Unknown command storage.' + method);
      }
      return elementMethods[method]('sessionStorage', { params: params, body: body });
    default:
      throwError(9, 'Unknown command ' + level + '.' + method);

  }
}

process.on('message', function (message) {
  _promise2.default.resolve(null).then(function () {
    return handleMessage(message);
  }).then(function (result) {
    process.send({ status: 0, value: result });
  }, function (err) {
    if (err.webdriverError) {
      process.send(err.webdriverError);
    } else {
      process.send({ status: 13, value: { message: err.stack } });
    }
  });
});